package cn.ibizlab.ehr.core.att.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.att.domain.AttEndanceDate;
import cn.ibizlab.ehr.core.att.filter.AttEndanceDateSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[AttEndanceDate] 服务对象接口
 */
public interface IAttEndanceDateService extends IService<AttEndanceDate> {

    boolean create(AttEndanceDate et);
    void createBatch(List<AttEndanceDate> list);
    boolean update(AttEndanceDate et);
    void updateBatch(List<AttEndanceDate> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    AttEndanceDate get(String key);
    AttEndanceDate getDraft(AttEndanceDate et);
    boolean checkKey(AttEndanceDate et);
    boolean save(AttEndanceDate et);
    void saveBatch(List<AttEndanceDate> list);
    Page<AttEndanceDate> searchDefault(AttEndanceDateSearchContext context);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<AttEndanceDate> getAttendancedateByIds(List<String> ids);
    List<AttEndanceDate> getAttendancedateByEntities(List<AttEndanceDate> entities);
}


