package cn.ibizlab.ehr.core.att.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.att.domain.AttEnsummary;
import cn.ibizlab.ehr.core.att.filter.AttEnsummarySearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[AttEnsummary] 服务对象接口
 */
public interface IAttEnsummaryService extends IService<AttEnsummary> {

    boolean create(AttEnsummary et);
    void createBatch(List<AttEnsummary> list);
    boolean update(AttEnsummary et);
    void updateBatch(List<AttEnsummary> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    AttEnsummary get(String key);
    AttEnsummary getDraft(AttEnsummary et);
    boolean checkKey(AttEnsummary et);
    AttEnsummary exportKQHZ(AttEnsummary et);
    boolean save(AttEnsummary et);
    void saveBatch(List<AttEnsummary> list);
    Page<AttEnsummary> searchCurZZKQHZ(AttEnsummarySearchContext context);
    Page<AttEnsummary> searchDefault(AttEnsummarySearchContext context);
    List<AttEnsummary> selectByPimpersonid(String pimpersonid);
    void removeByPimpersonid(String pimpersonid);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<AttEnsummary> getAttensummaryByIds(List<String> ids);
    List<AttEnsummary> getAttensummaryByEntities(List<AttEnsummary> entities);
}


