package cn.ibizlab.ehr.core.att.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.att.domain.AttEnsummarymx;
import cn.ibizlab.ehr.core.att.filter.AttEnsummarymxSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[AttEnsummarymx] 服务对象接口
 */
public interface IAttEnsummarymxService extends IService<AttEnsummarymx> {

    boolean create(AttEnsummarymx et);
    void createBatch(List<AttEnsummarymx> list);
    boolean update(AttEnsummarymx et);
    void updateBatch(List<AttEnsummarymx> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    AttEnsummarymx get(String key);
    AttEnsummarymx getDraft(AttEnsummarymx et);
    boolean checkKey(AttEnsummarymx et);
    boolean save(AttEnsummarymx et);
    void saveBatch(List<AttEnsummarymx> list);
    Page<AttEnsummarymx> searchDefault(AttEnsummarymxSearchContext context);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<AttEnsummarymx> getAttensummarymxByIds(List<String> ids);
    List<AttEnsummarymx> getAttensummarymxByEntities(List<AttEnsummarymx> entities);
}


