package cn.ibizlab.ehr.core.att.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.ehr.core.att.domain.ATTENDANCERECORD;
import cn.ibizlab.ehr.core.att.filter.ATTENDANCERECORDSearchContext;
import cn.ibizlab.ehr.core.att.service.IATTENDANCERECORDService;

import cn.ibizlab.ehr.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.ehr.core.att.mapper.ATTENDANCERECORDMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[考勤记录] 服务对象接口实现
 */
@Slf4j
@Service("ATTENDANCERECORDServiceImpl")
public class ATTENDANCERECORDServiceImpl extends ServiceImpl<ATTENDANCERECORDMapper, ATTENDANCERECORD> implements IATTENDANCERECORDService {

    @Autowired
    @Lazy
    private cn.ibizlab.ehr.core.att.service.IAttendRecordDetailService attendrecorddetailService;
    @Autowired
    @Lazy
    private cn.ibizlab.ehr.core.att.service.IATTENDANCEMREPORTMXService attendancemreportmxService;
    @Autowired
    @Lazy
    private cn.ibizlab.ehr.core.orm.service.IORMBMKQDZService ormbmkqdzService;
    @Autowired
    @Lazy
    private cn.ibizlab.ehr.core.pim.service.IPIMPERSONService pimpersonService;
    @Autowired
    @Lazy
    private cn.ibizlab.ehr.core.trm.service.ITRMTRAINPLANTERMService trmtrainplantermService;

    private int batchSize = 500;

    @Override
    public ATTENDANCERECORD getDraft(ATTENDANCERECORD et) {
        fillParentData(et);
        return et;
    }

    @Override
    @Transactional
    public boolean create(ATTENDANCERECORD et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getAttendancerecordid()),et);
        return true;
    }

    @Override
    public void createBatch(List<ATTENDANCERECORD> list) {
        list.forEach(item->fillParentData(item));
        saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(ATTENDANCERECORD et) {
        fillParentData(et);
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("attendancerecordid",et.getAttendancerecordid())))
            return false;
        CachedBeanCopier.copy(get(et.getAttendancerecordid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<ATTENDANCERECORD> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public boolean save(ATTENDANCERECORD et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(ATTENDANCERECORD et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<ATTENDANCERECORD> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    @Transactional
    public ATTENDANCERECORD get(String key) {
        ATTENDANCERECORD et = getById(key);
        if(et==null){
            et=new ATTENDANCERECORD();
            et.setAttendancerecordid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public ATTENDANCERECORD reflushPersonInfo(ATTENDANCERECORD et) {
        //自定义代码
        return et;
    }

    @Override
    public boolean checkKey(ATTENDANCERECORD et) {
        return (!ObjectUtils.isEmpty(et.getAttendancerecordid()))&&(!Objects.isNull(this.getById(et.getAttendancerecordid())));
    }


	@Override
    public List<ATTENDANCERECORD> selectByAttendancemreportid(String attendancemreportmxid) {
        return baseMapper.selectByAttendancemreportid(attendancemreportmxid);
    }

    @Override
    public void removeByAttendancemreportid(String attendancemreportmxid) {
        this.remove(new QueryWrapper<ATTENDANCERECORD>().eq("attendancemreportmxid",attendancemreportmxid));
    }

	@Override
    public List<ATTENDANCERECORD> selectByOrmbmkqdzid(String ormbmkqdzid) {
        return baseMapper.selectByOrmbmkqdzid(ormbmkqdzid);
    }

    @Override
    public void removeByOrmbmkqdzid(String ormbmkqdzid) {
        this.remove(new QueryWrapper<ATTENDANCERECORD>().eq("ormbmkqdzid",ormbmkqdzid));
    }

	@Override
    public List<ATTENDANCERECORD> selectByPimpersonid(String pimpersonid) {
        return baseMapper.selectByPimpersonid(pimpersonid);
    }

    @Override
    public void removeByPimpersonid(String pimpersonid) {
        this.remove(new QueryWrapper<ATTENDANCERECORD>().eq("pimpersonid",pimpersonid));
    }

	@Override
    public List<ATTENDANCERECORD> selectByTrmtrainplantermid(String trmtrainplantermid) {
        return baseMapper.selectByTrmtrainplantermid(trmtrainplantermid);
    }

    @Override
    public void removeByTrmtrainplantermid(String trmtrainplantermid) {
        this.remove(new QueryWrapper<ATTENDANCERECORD>().eq("trmtrainplantermid",trmtrainplantermid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<ATTENDANCERECORD> searchDefault(ATTENDANCERECORDSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<ATTENDANCERECORD> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<ATTENDANCERECORD>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(ATTENDANCERECORD et){
        //实体关系[DER1N_ATTENDANCERECORD_ATTENDANCEMREPORTMX_ATTENDANCEMREPORTMXID]
        if(!ObjectUtils.isEmpty(et.getAttendancemreportid())){
            cn.ibizlab.ehr.core.att.domain.ATTENDANCEMREPORTMX attendancemreportmx=et.getAttendancemreportmx();
            if(ObjectUtils.isEmpty(attendancemreportmx)){
                cn.ibizlab.ehr.core.att.domain.ATTENDANCEMREPORTMX majorEntity=attendancemreportmxService.get(et.getAttendancemreportid());
                et.setAttendancemreportmx(majorEntity);
                attendancemreportmx=majorEntity;
            }
            et.setAttendancemreportmxname(attendancemreportmx.getAttendancemreportname());
        }
        //实体关系[DER1N_ATTENDANCERECORD_ORMBMKQDZ_ORMBMKQDZID]
        if(!ObjectUtils.isEmpty(et.getOrmbmkqdzid())){
            cn.ibizlab.ehr.core.orm.domain.ORMBMKQDZ ormbmkqdz=et.getOrmbmkqdz();
            if(ObjectUtils.isEmpty(ormbmkqdz)){
                cn.ibizlab.ehr.core.orm.domain.ORMBMKQDZ majorEntity=ormbmkqdzService.get(et.getOrmbmkqdzid());
                et.setOrmbmkqdz(majorEntity);
                ormbmkqdz=majorEntity;
            }
            et.setOrmbmkqdzname(ormbmkqdz.getOrmbmkqdzname());
        }
        //实体关系[DER1N_ATTENDANCERECORD_PIMPERSON_PIMPERSONID]
        if(!ObjectUtils.isEmpty(et.getPimpersonid())){
            cn.ibizlab.ehr.core.pim.domain.PIMPERSON pimperson=et.getPimperson();
            if(ObjectUtils.isEmpty(pimperson)){
                cn.ibizlab.ehr.core.pim.domain.PIMPERSON majorEntity=pimpersonService.get(et.getPimpersonid());
                et.setPimperson(majorEntity);
                pimperson=majorEntity;
            }
            et.setPimpersonname(pimperson.getPimpersonname());
            et.setOrmorgsectorname(pimperson.getOrmorgsectorname());
            et.setYgbh(pimperson.getYgbh());
            et.setOrmorgsectorid(pimperson.getOrmorgsectorid());
            et.setZzdzs(pimperson.getZzdzs());
            et.setZjhm(pimperson.getZjhm());
            et.setOrmorgid(pimperson.getOrmorgid());
            et.setOrmorgname(pimperson.getZzdzs());
        }
        //实体关系[DER1N_ATTENDANCERECORD_TRMTRAINPLANTERM_TRMTRAINPLANTERMID]
        if(!ObjectUtils.isEmpty(et.getTrmtrainplantermid())){
            cn.ibizlab.ehr.core.trm.domain.TRMTRAINPLANTERM trmtrainplanterm=et.getTrmtrainplanterm();
            if(ObjectUtils.isEmpty(trmtrainplanterm)){
                cn.ibizlab.ehr.core.trm.domain.TRMTRAINPLANTERM majorEntity=trmtrainplantermService.get(et.getTrmtrainplantermid());
                et.setTrmtrainplanterm(majorEntity);
                trmtrainplanterm=majorEntity;
            }
            et.setTrmtrainplantermname(trmtrainplanterm.getTrmtrainplantermname());
        }
    }

    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


