package cn.ibizlab.ehr.core.common.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.common.domain.CodeItem;
import cn.ibizlab.ehr.core.common.filter.CodeItemSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[CodeItem] 服务对象接口
 */
public interface ICodeItemService extends IService<CodeItem> {

    boolean create(CodeItem et);
    void createBatch(List<CodeItem> list);
    boolean update(CodeItem et);
    void updateBatch(List<CodeItem> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    CodeItem get(String key);
    CodeItem getDraft(CodeItem et);
    boolean checkKey(CodeItem et);
    boolean save(CodeItem et);
    void saveBatch(List<CodeItem> list);
    Page<CodeItem> searchCurCL(CodeItemSearchContext context);
    Page<CodeItem> searchDefault(CodeItemSearchContext context);
    List<CodeItem> selectByPcodeitemid(String codeitemid);
    void removeByPcodeitemid(Collection<String> ids);
    void removeByPcodeitemid(String codeitemid);
    List<CodeItem> selectByCodelistid(String codelistid);
    void removeByCodelistid(Collection<String> ids);
    void removeByCodelistid(String codelistid);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<CodeItem> getCodeitemByIds(List<String> ids);
    List<CodeItem> getCodeitemByEntities(List<CodeItem> entities);
}


