package cn.ibizlab.ehr.core.orm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.ehr.core.orm.domain.ORMPostLib;
import cn.ibizlab.ehr.core.orm.filter.ORMPostLibSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[ORMPostLib] 服务对象接口
 */
public interface IORMPostLibService extends IService<ORMPostLib>{

    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(ORMPostLib et) ;
    void saveBatch(List<ORMPostLib> list) ;
    boolean update(ORMPostLib et) ;
    void updateBatch(List<ORMPostLib> list) ;
    boolean create(ORMPostLib et) ;
    void createBatch(List<ORMPostLib> list) ;
    ORMPostLib getDraft(ORMPostLib et) ;
    ORMPostLib get(String key) ;
    boolean checkKey(ORMPostLib et) ;
    Page<ORMPostLib> searchDefault(ORMPostLibSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


