package cn.ibizlab.ehr.core.orm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.orm.domain.OrmOrgsector;
import cn.ibizlab.ehr.core.orm.filter.OrmOrgsectorSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[OrmOrgsector] 服务对象接口
 */
public interface IOrmOrgsectorService extends IService<OrmOrgsector> {

    boolean create(OrmOrgsector et);
    void createBatch(List<OrmOrgsector> list);
    boolean update(OrmOrgsector et);
    void updateBatch(List<OrmOrgsector> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    OrmOrgsector get(String key);
    OrmOrgsector getDraft(OrmOrgsector et);
    OrmOrgsector cLWC(OrmOrgsector et);
    OrmOrgsector changeEdition(OrmOrgsector et);
    boolean checkKey(OrmOrgsector et);
    boolean save(OrmOrgsector et);
    void saveBatch(List<OrmOrgsector> list);
    OrmOrgsector synOrgSec(OrmOrgsector et);
    OrmOrgsector synOrgSectOderNum(OrmOrgsector et);
    OrmOrgsector synOrgSectPro(OrmOrgsector et);
    OrmOrgsector tJ(OrmOrgsector et);
    Page<OrmOrgsector> searchBMBZGL(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchBaseInfo(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchCURORG(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchCURORMORG(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchCurOrgSector(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchCurZZBM(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchCurZZBM_KQSZ(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchDQZZXBM(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchDefault(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchHisInfo(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchJSYXMB(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchPimpersonInfoOrgsector(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchProExpandInfo(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchRsshInfo(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchSubOrgsector(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchSubZZBM(OrmOrgsectorSearchContext context);
    Page<OrmOrgsector> searchXMBBZGL(OrmOrgsectorSearchContext context);
    List<OrmOrgsector> selectByPorgsectorid(String orgsectorid);
    List<OrmOrgsector> selectByPorgsectorid(Collection<String> ids);
    void removeByPorgsectorid(String orgsectorid);
    List<OrmOrgsector> selectByProdepid(String orgsectorid);
    void resetByProdepid(String orgsectorid);
    void resetByProdepid(Collection<String> ids);
    void removeByProdepid(String orgsectorid);
    List<OrmOrgsector> selectByOrgid(String orgid);
    List<OrmOrgsector> selectByOrgid(Collection<String> ids);
    void removeByOrgid(String orgid);
    List<OrmOrgsector> selectByOrmxmglid(String ormxmglid);
    void resetByOrmxmglid(String ormxmglid);
    void resetByOrmxmglid(Collection<String> ids);
    void removeByOrmxmglid(String ormxmglid);
    List<OrmOrgsector> selectByPimpersonid(String pimpersonid);
    void resetByPimpersonid(String pimpersonid);
    void resetByPimpersonid(Collection<String> ids);
    void removeByPimpersonid(String pimpersonid);
    List<OrmOrgsector> selectByProleaderid(String pimpersonid);
    void removeByProleaderid(String pimpersonid);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<OrmOrgsector> getOrmorgsectorByIds(List<String> ids);
    List<OrmOrgsector> getOrmorgsectorByEntities(List<OrmOrgsector> entities);
}


