package cn.ibizlab.ehr.core.orm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.orm.domain.OrmXmrlcb;
import cn.ibizlab.ehr.core.orm.filter.OrmXmrlcbSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[OrmXmrlcb] 服务对象接口
 */
public interface IOrmXmrlcbService extends IService<OrmXmrlcb> {

    boolean create(OrmXmrlcb et);
    void createBatch(List<OrmXmrlcb> list);
    boolean update(OrmXmrlcb et);
    void updateBatch(List<OrmXmrlcb> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    OrmXmrlcb get(String key);
    OrmXmrlcb getDraft(OrmXmrlcb et);
    boolean checkKey(OrmXmrlcb et);
    boolean save(OrmXmrlcb et);
    void saveBatch(List<OrmXmrlcb> list);
    Page<OrmXmrlcb> searchCBCX(OrmXmrlcbSearchContext context);
    Page<OrmXmrlcb> searchDefault(OrmXmrlcbSearchContext context);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<OrmXmrlcb> getOrmxmrlcbByIds(List<String> ids);
    List<OrmXmrlcb> getOrmxmrlcbByEntities(List<OrmXmrlcb> entities);
}


