package cn.ibizlab.ehr.core.par.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.ehr.core.par.domain.PARJXKHMB;
import cn.ibizlab.ehr.core.par.filter.PARJXKHMBSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PARJXKHMB] 服务对象接口
 */
public interface IPARJXKHMBService extends IService<PARJXKHMB>{

    boolean checkKey(PARJXKHMB et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    PARJXKHMB get(String key) ;
    boolean create(PARJXKHMB et) ;
    void createBatch(List<PARJXKHMB> list) ;
    PARJXKHMB getDraft(PARJXKHMB et) ;
    boolean save(PARJXKHMB et) ;
    void saveBatch(List<PARJXKHMB> list) ;
    boolean update(PARJXKHMB et) ;
    void updateBatch(List<PARJXKHMB> list) ;
    Page<PARJXKHMB> searchDefault(PARJXKHMBSearchContext context) ;
    List<PARJXKHMB> selectByOrmorgid(String orgid) ;
    void removeByOrmorgid(String orgid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


