package cn.ibizlab.ehr.core.par.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.ehr.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.ehr.core.par.domain.ParPtryndlhmb;
import cn.ibizlab.ehr.core.par.filter.ParPtryndlhmbSearchContext;
import cn.ibizlab.ehr.core.par.service.IParPtryndlhmbService;

import cn.ibizlab.ehr.util.helper.CachedBeanCopier;
import cn.ibizlab.ehr.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.ehr.core.par.mapper.ParPtryndlhmbMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[年度量化目标（部门副职及以下人员）] 服务对象接口实现
 */
@Slf4j
@Service("ParPtryndlhmbServiceImpl")
public class ParPtryndlhmbServiceImpl extends ServiceImpl<ParPtryndlhmbMapper, ParPtryndlhmb> implements IParPtryndlhmbService {

    @Autowired
    @Lazy
    protected cn.ibizlab.ehr.core.par.service.IParPtryndlhmbmxService parptryndlhmbmxService;
    @Autowired
    @Lazy
    protected cn.ibizlab.ehr.core.pim.service.IPimPersonService pimpersonService;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(ParPtryndlhmb et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getParptryndlhmbid()), et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<ParPtryndlhmb> list) {
        list.forEach(item->fillParentData(item));
        this.saveBatch(list, batchSize);
    }

    @Override
    @Transactional
    public boolean update(ParPtryndlhmb et) {
        fillParentData(et);
        if(!update(et, (Wrapper) et.getUpdateWrapper(true).eq("parptryndlhmbid", et.getParptryndlhmbid()))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getParptryndlhmbid()), et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<ParPtryndlhmb> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list, batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        parptryndlhmbmxService.resetByParptryndlhmbid(key);
        boolean result = removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        parptryndlhmbmxService.resetByParptryndlhmbid(idList);
        removeByIds(idList);
    }

    @Override
    @Transactional
    public ParPtryndlhmb get(String key) {
        ParPtryndlhmb et = getById(key);
        if(et == null){
            et = new ParPtryndlhmb();
            et.setParptryndlhmbid(key);
        }
        else {
        }
        return et;
    }

    @Override
    public ParPtryndlhmb getDraft(ParPtryndlhmb et) {
        fillParentData(et);
        return et;
    }

    @Override
    public boolean checkKey(ParPtryndlhmb et) {
        return (!ObjectUtils.isEmpty(et.getParptryndlhmbid())) && (!Objects.isNull(this.getById(et.getParptryndlhmbid())));
    }
    @Override
    @Transactional
    public boolean save(ParPtryndlhmb et) {
        if(!saveOrUpdate(et)) {
            return false;
        }
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(ParPtryndlhmb et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<ParPtryndlhmb> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<ParPtryndlhmb> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }


	@Override
    public List<ParPtryndlhmb> selectByPimpersonid(String pimpersonid) {
        return baseMapper.selectByPimpersonid(pimpersonid);
    }
    @Override
    public void resetByPimpersonid(String pimpersonid) {
        this.update(new UpdateWrapper<ParPtryndlhmb>().set("pimpersonid",null).eq("pimpersonid",pimpersonid));
    }

    @Override
    public void resetByPimpersonid(Collection<String> ids) {
        this.update(new UpdateWrapper<ParPtryndlhmb>().set("pimpersonid",null).in("pimpersonid",ids));
    }

    @Override
    public void removeByPimpersonid(String pimpersonid) {
        this.remove(new QueryWrapper<ParPtryndlhmb>().eq("pimpersonid",pimpersonid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<ParPtryndlhmb> searchDefault(ParPtryndlhmbSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<ParPtryndlhmb> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<ParPtryndlhmb>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(ParPtryndlhmb et){
        //实体关系[DER1N_PARPTRYNDLHMB_PIMPERSON_PIMPERSONID]
        if(!ObjectUtils.isEmpty(et.getPimpersonid())){
            cn.ibizlab.ehr.core.pim.domain.PimPerson pimperson=et.getPimperson();
            if(ObjectUtils.isEmpty(pimperson)){
                cn.ibizlab.ehr.core.pim.domain.PimPerson majorEntity=pimpersonService.get(et.getPimpersonid());
                et.setPimperson(majorEntity);
                pimperson=majorEntity;
            }
            et.setPimpersonname(pimperson.getPimpersonname());
        }
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<ParPtryndlhmb> getParptryndlhmbByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<ParPtryndlhmb> getParptryndlhmbByEntities(List<ParPtryndlhmb> entities) {
        List ids =new ArrayList();
        for(ParPtryndlhmb entity : entities){
            Serializable id=entity.getParptryndlhmbid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0) {
            return this.listByIds(ids);
        }
        else {
            return entities;
        }
    }




}



