package cn.ibizlab.ehr.core.pcm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.pcm.domain.PcmBdsqdmx;
import cn.ibizlab.ehr.core.pcm.filter.PcmBdsqdmxSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PcmBdsqdmx] 服务对象接口
 */
public interface IPcmBdsqdmxService extends IService<PcmBdsqdmx> {

    boolean create(PcmBdsqdmx et);
    void createBatch(List<PcmBdsqdmx> list);
    boolean update(PcmBdsqdmx et);
    void updateBatch(List<PcmBdsqdmx> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    PcmBdsqdmx get(String key);
    PcmBdsqdmx getDraft(PcmBdsqdmx et);
    PcmBdsqdmx cQBXCZ(PcmBdsqdmx et);
    boolean checkKey(PcmBdsqdmx et);
    PcmBdsqdmx dGCZ(PcmBdsqdmx et);
    PcmBdsqdmx gZCZ(PcmBdsqdmx et);
    PcmBdsqdmx jPCZ(PcmBdsqdmx et);
    PcmBdsqdmx jZJJSDMB(PcmBdsqdmx et);
    PcmBdsqdmx lZCZ(PcmBdsqdmx et);
    PcmBdsqdmx nTCZ(PcmBdsqdmx et);
    PcmBdsqdmx pDZJ(PcmBdsqdmx et);
    PcmBdsqdmx sHBTG(PcmBdsqdmx et);
    PcmBdsqdmx sHTG(PcmBdsqdmx et);
    PcmBdsqdmx sXDMB(PcmBdsqdmx et);
    PcmBdsqdmx sXJSDMB(PcmBdsqdmx et);
    PcmBdsqdmx sXJSDMB2(PcmBdsqdmx et);
    boolean save(PcmBdsqdmx et);
    void saveBatch(List<PcmBdsqdmx> list);
    PcmBdsqdmx setPersonInfo(PcmBdsqdmx et);
    PcmBdsqdmx tXCZ(PcmBdsqdmx et);
    PcmBdsqdmx zJBDCZ(PcmBdsqdmx et);
    PcmBdsqdmx zJJSDMB(PcmBdsqdmx et);
    PcmBdsqdmx zZSQ(PcmBdsqdmx et);
    Page<PcmBdsqdmx> searchCQBXSQMXDS(PcmBdsqdmxSearchContext context);
    Page<PcmBdsqdmx> searchDGSQMX(PcmBdsqdmxSearchContext context);
    Page<PcmBdsqdmx> searchDefault(PcmBdsqdmxSearchContext context);
    Page<PcmBdsqdmx> searchGZSQMX(PcmBdsqdmxSearchContext context);
    Page<PcmBdsqdmx> searchJPSQMX(PcmBdsqdmxSearchContext context);
    Page<PcmBdsqdmx> searchLZSQMX(PcmBdsqdmxSearchContext context);
    Page<PcmBdsqdmx> searchLZSQMXGR(PcmBdsqdmxSearchContext context);
    Page<PcmBdsqdmx> searchNTSQMX(PcmBdsqdmxSearchContext context);
    Page<PcmBdsqdmx> searchNTSQMXGR(PcmBdsqdmxSearchContext context);
    Page<PcmBdsqdmx> searchTXSQMX(PcmBdsqdmxSearchContext context);
    Page<PcmBdsqdmx> searchZJBDSQMX(PcmBdsqdmxSearchContext context);
    List<PcmBdsqdmx> selectByOrmdutyid(String ormdutyid);
    void removeByOrmdutyid(String ormdutyid);
    List<PcmBdsqdmx> selectByOrmorgsectorid(String orgsectorid);
    void resetByOrmorgsectorid(String orgsectorid);
    void resetByOrmorgsectorid(Collection<String> ids);
    void removeByOrmorgsectorid(String orgsectorid);
    List<PcmBdsqdmx> selectByOrmorgsectorid2(String orgsectorid);
    void removeByOrmorgsectorid2(String orgsectorid);
    List<PcmBdsqdmx> selectByOrmorgid(String orgid);
    void resetByOrmorgid(String orgid);
    void resetByOrmorgid(Collection<String> ids);
    void removeByOrmorgid(String orgid);
    List<PcmBdsqdmx> selectByOrmpostid(String ormpostid);
    void removeByOrmpostid(String ormpostid);
    List<PcmBdsqdmx> selectByPcmbdsqdid(String pcmbdsqdid);
    void resetByPcmbdsqdid(String pcmbdsqdid);
    void resetByPcmbdsqdid(Collection<String> ids);
    void removeByPcmbdsqdid(String pcmbdsqdid);
    List<PcmBdsqdmx> selectByLzmtrid(String pimpersonid);
    void removeByLzmtrid(String pimpersonid);
    List<PcmBdsqdmx> selectByPimpersonid(String pimpersonid);
    void resetByPimpersonid(String pimpersonid);
    void resetByPimpersonid(Collection<String> ids);
    void removeByPimpersonid(String pimpersonid);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<PcmBdsqdmx> getPcmbdsqdmxByIds(List<String> ids);
    List<PcmBdsqdmx> getPcmbdsqdmxByEntities(List<PcmBdsqdmx> entities);
}


