package cn.ibizlab.ehr.core.pcm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.pcm.domain.PcmDdsqdmx;
import cn.ibizlab.ehr.core.pcm.filter.PcmDdsqdmxSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PcmDdsqdmx] 服务对象接口
 */
public interface IPcmDdsqdmxService extends IService<PcmDdsqdmx> {

    boolean create(PcmDdsqdmx et);
    void createBatch(List<PcmDdsqdmx> list);
    boolean update(PcmDdsqdmx et);
    void updateBatch(List<PcmDdsqdmx> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    PcmDdsqdmx get(String key);
    PcmDdsqdmx getDraft(PcmDdsqdmx et);
    boolean checkKey(PcmDdsqdmx et);
    PcmDdsqdmx dDCZ(PcmDdsqdmx et);
    PcmDdsqdmx dDCreate(PcmDdsqdmx et);
    PcmDdsqdmx dDUpdate(PcmDdsqdmx et);
    PcmDdsqdmx jDCZ(PcmDdsqdmx et);
    PcmDdsqdmx jZCZ(PcmDdsqdmx et);
    PcmDdsqdmx sQBTG(PcmDdsqdmx et);
    PcmDdsqdmx sQTG(PcmDdsqdmx et);
    boolean save(PcmDdsqdmx et);
    void saveBatch(List<PcmDdsqdmx> list);
    PcmDdsqdmx zZSQ(PcmDdsqdmx et);
    Page<PcmDdsqdmx> searchDDJL(PcmDdsqdmxSearchContext context);
    Page<PcmDdsqdmx> searchDDMX(PcmDdsqdmxSearchContext context);
    Page<PcmDdsqdmx> searchDDSQGR(PcmDdsqdmxSearchContext context);
    Page<PcmDdsqdmx> searchDefault(PcmDdsqdmxSearchContext context);
    Page<PcmDdsqdmx> searchGBDDJL(PcmDdsqdmxSearchContext context);
    Page<PcmDdsqdmx> searchJDSQGR(PcmDdsqdmxSearchContext context);
    Page<PcmDdsqdmx> searchJDSQMX(PcmDdsqdmxSearchContext context);
    Page<PcmDdsqdmx> searchJZSQGR(PcmDdsqdmxSearchContext context);
    Page<PcmDdsqdmx> searchJZSQMX(PcmDdsqdmxSearchContext context);
    List<PcmDdsqdmx> selectByOrmdutyid(String ormdutyid);
    void resetByOrmdutyid(String ormdutyid);
    void resetByOrmdutyid(Collection<String> ids);
    void removeByOrmdutyid(String ormdutyid);
    List<PcmDdsqdmx> selectByOrgsectorid(String orgsectorid);
    void resetByOrgsectorid(String orgsectorid);
    void resetByOrgsectorid(Collection<String> ids);
    void removeByOrgsectorid(String orgsectorid);
    List<PcmDdsqdmx> selectByOrgid(String orgid);
    void resetByOrgid(String orgid);
    void resetByOrgid(Collection<String> ids);
    void removeByOrgid(String orgid);
    List<PcmDdsqdmx> selectByOrmpostid(String ormpostid);
    void resetByOrmpostid(String ormpostid);
    void resetByOrmpostid(Collection<String> ids);
    void removeByOrmpostid(String ormpostid);
    List<PcmDdsqdmx> selectByPcmddsqdid(String pcmddsqdid);
    void resetByPcmddsqdid(String pcmddsqdid);
    void resetByPcmddsqdid(Collection<String> ids);
    void removeByPcmddsqdid(String pcmddsqdid);
    List<PcmDdsqdmx> selectByPimdistirbutionid(String pimdistirbutionid);
    void resetByPimdistirbutionid(String pimdistirbutionid);
    void resetByPimdistirbutionid(Collection<String> ids);
    void removeByPimdistirbutionid(String pimdistirbutionid);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<PcmDdsqdmx> getPcmddsqdmxByIds(List<String> ids);
    List<PcmDdsqdmx> getPcmddsqdmxByEntities(List<PcmDdsqdmx> entities);
}


