package cn.ibizlab.ehr.core.pcm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.pcm.domain.PcmProfileNumBeprefix;
import cn.ibizlab.ehr.core.pcm.filter.PcmProfileNumBeprefixSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PcmProfileNumBeprefix] 服务对象接口
 */
public interface IPcmProfileNumBeprefixService extends IService<PcmProfileNumBeprefix> {

    boolean create(PcmProfileNumBeprefix et);
    void createBatch(List<PcmProfileNumBeprefix> list);
    boolean update(PcmProfileNumBeprefix et);
    void updateBatch(List<PcmProfileNumBeprefix> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    PcmProfileNumBeprefix get(String key);
    PcmProfileNumBeprefix getDraft(PcmProfileNumBeprefix et);
    boolean checkKey(PcmProfileNumBeprefix et);
    boolean save(PcmProfileNumBeprefix et);
    void saveBatch(List<PcmProfileNumBeprefix> list);
    Page<PcmProfileNumBeprefix> searchDefault(PcmProfileNumBeprefixSearchContext context);
    List<PcmProfileNumBeprefix> selectByOrmorgid(String orgid);
    void removeByOrmorgid(String orgid);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<PcmProfileNumBeprefix> getPcmprofilenumbeprefixByIds(List<String> ids);
    List<PcmProfileNumBeprefix> getPcmprofilenumbeprefixByEntities(List<PcmProfileNumBeprefix> entities);
}


