package cn.ibizlab.ehr.core.pcm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.pcm.domain.PcmProfileYjtjTemp;
import cn.ibizlab.ehr.core.pcm.filter.PcmProfileYjtjTempSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PcmProfileYjtjTemp] 服务对象接口
 */
public interface IPcmProfileYjtjTempService extends IService<PcmProfileYjtjTemp> {

    boolean create(PcmProfileYjtjTemp et);
    void createBatch(List<PcmProfileYjtjTemp> list);
    boolean update(PcmProfileYjtjTemp et);
    void updateBatch(List<PcmProfileYjtjTemp> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    PcmProfileYjtjTemp get(String key);
    PcmProfileYjtjTemp getDraft(PcmProfileYjtjTemp et);
    boolean checkKey(PcmProfileYjtjTemp et);
    boolean save(PcmProfileYjtjTemp et);
    void saveBatch(List<PcmProfileYjtjTemp> list);
    Page<PcmProfileYjtjTemp> searchDefault(PcmProfileYjtjTempSearchContext context);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<PcmProfileYjtjTemp> getPcmprofileyjtjtempByIds(List<String> ids);
    List<PcmProfileYjtjTemp> getPcmprofileyjtjtempByEntities(List<PcmProfileYjtjTemp> entities);
}


