package cn.ibizlab.ehr.core.pcm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.pcm.domain.PcmXygzzkhjgjl;
import cn.ibizlab.ehr.core.pcm.filter.PcmXygzzkhjgjlSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PcmXygzzkhjgjl] 服务对象接口
 */
public interface IPcmXygzzkhjgjlService extends IService<PcmXygzzkhjgjl> {

    boolean create(PcmXygzzkhjgjl et);
    void createBatch(List<PcmXygzzkhjgjl> list);
    boolean update(PcmXygzzkhjgjl et);
    void updateBatch(List<PcmXygzzkhjgjl> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    PcmXygzzkhjgjl get(String key);
    PcmXygzzkhjgjl getDraft(PcmXygzzkhjgjl et);
    boolean checkKey(PcmXygzzkhjgjl et);
    boolean save(PcmXygzzkhjgjl et);
    void saveBatch(List<PcmXygzzkhjgjl> list);
    Page<PcmXygzzkhjgjl> searchDefault(PcmXygzzkhjgjlSearchContext context);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<PcmXygzzkhjgjl> getPcmxygzzkhjgjlByIds(List<String> ids);
    List<PcmXygzzkhjgjl> getPcmxygzzkhjgjlByEntities(List<PcmXygzzkhjgjl> entities);
}


