package cn.ibizlab.ehr.core.pcm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.pcm.domain.PcmZpmeglmx;
import cn.ibizlab.ehr.core.pcm.filter.PcmZpmeglmxSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PcmZpmeglmx] 服务对象接口
 */
public interface IPcmZpmeglmxService extends IService<PcmZpmeglmx> {

    boolean create(PcmZpmeglmx et);
    void createBatch(List<PcmZpmeglmx> list);
    boolean update(PcmZpmeglmx et);
    void updateBatch(List<PcmZpmeglmx> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    PcmZpmeglmx get(String key);
    PcmZpmeglmx getDraft(PcmZpmeglmx et);
    boolean checkKey(PcmZpmeglmx et);
    boolean save(PcmZpmeglmx et);
    void saveBatch(List<PcmZpmeglmx> list);
    Page<PcmZpmeglmx> searchDefault(PcmZpmeglmxSearchContext context);
    List<PcmZpmeglmx> selectByPcmzpmeglid(String pcmzpmeglid);
    void resetByPcmzpmeglid(String pcmzpmeglid);
    void resetByPcmzpmeglid(Collection<String> ids);
    void removeByPcmzpmeglid(String pcmzpmeglid);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<PcmZpmeglmx> getPcmzpmeglmxByIds(List<String> ids);
    List<PcmZpmeglmx> getPcmzpmeglmxByEntities(List<PcmZpmeglmx> entities);
}


