package cn.ibizlab.ehr.core.pcm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.pcm.domain.PcmZsgl;
import cn.ibizlab.ehr.core.pcm.filter.PcmZsglSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PcmZsgl] 服务对象接口
 */
public interface IPcmZsglService extends IService<PcmZsgl> {

    boolean create(PcmZsgl et);
    void createBatch(List<PcmZsgl> list);
    boolean update(PcmZsgl et);
    void updateBatch(List<PcmZsgl> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    PcmZsgl get(String key);
    PcmZsgl getDraft(PcmZsgl et);
    boolean checkKey(PcmZsgl et);
    boolean save(PcmZsgl et);
    void saveBatch(List<PcmZsgl> list);
    Page<PcmZsgl> searchDefault(PcmZsglSearchContext context);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<PcmZsgl> getPcmzsglByIds(List<String> ids);
    List<PcmZsgl> getPcmzsglByEntities(List<PcmZsgl> entities);
}


