package cn.ibizlab.ehr.core.pcm.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.ehr.core.pcm.domain.PCMPROFILEYJTJTEMP;
import cn.ibizlab.ehr.core.pcm.filter.PCMPROFILEYJTJTEMPSearchContext;
import cn.ibizlab.ehr.core.pcm.service.IPCMPROFILEYJTJTEMPService;

import cn.ibizlab.ehr.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.ehr.core.pcm.mapper.PCMPROFILEYJTJTEMPMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[应聘者引进条件中间表（停用）] 服务对象接口实现
 */
@Slf4j
@Service("PCMPROFILEYJTJTEMPServiceImpl")
public class PCMPROFILEYJTJTEMPServiceImpl extends ServiceImpl<PCMPROFILEYJTJTEMPMapper, PCMPROFILEYJTJTEMP> implements IPCMPROFILEYJTJTEMPService {


    private int batchSize = 500;

    @Override
    @Transactional
    public boolean update(PCMPROFILEYJTJTEMP et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("pcmprofileyjtjtempid",et.getPcmprofileyjtjtempid())))
            return false;
        CachedBeanCopier.copy(get(et.getPcmprofileyjtjtempid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<PCMPROFILEYJTJTEMP> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    public PCMPROFILEYJTJTEMP getDraft(PCMPROFILEYJTJTEMP et) {
        return et;
    }

    @Override
    @Transactional
    public boolean create(PCMPROFILEYJTJTEMP et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getPcmprofileyjtjtempid()),et);
        return true;
    }

    @Override
    public void createBatch(List<PCMPROFILEYJTJTEMP> list) {
        saveBatch(list,batchSize);
    }

    @Override
    public boolean checkKey(PCMPROFILEYJTJTEMP et) {
        return (!ObjectUtils.isEmpty(et.getPcmprofileyjtjtempid()))&&(!Objects.isNull(this.getById(et.getPcmprofileyjtjtempid())));
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public boolean save(PCMPROFILEYJTJTEMP et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(PCMPROFILEYJTJTEMP et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<PCMPROFILEYJTJTEMP> list) {
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    @Transactional
    public PCMPROFILEYJTJTEMP get(String key) {
        PCMPROFILEYJTJTEMP et = getById(key);
        if(et==null){
            et=new PCMPROFILEYJTJTEMP();
            et.setPcmprofileyjtjtempid(key);
        }
        else{
        }
        return et;
    }



    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PCMPROFILEYJTJTEMP> searchDefault(PCMPROFILEYJTJTEMPSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PCMPROFILEYJTJTEMP> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<PCMPROFILEYJTJTEMP>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


