package cn.ibizlab.ehr.core.pcm.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.ehr.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.ehr.core.pcm.domain.PcmYpzjkxx;
import cn.ibizlab.ehr.core.pcm.filter.PcmYpzjkxxSearchContext;
import cn.ibizlab.ehr.core.pcm.service.IPcmYpzjkxxService;

import cn.ibizlab.ehr.util.helper.CachedBeanCopier;
import cn.ibizlab.ehr.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.ehr.core.pcm.mapper.PcmYpzjkxxMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[应聘者接口信息管理] 服务对象接口实现
 */
@Slf4j
@Service("PcmYpzjkxxServiceImpl")
public class PcmYpzjkxxServiceImpl extends ServiceImpl<PcmYpzjkxxMapper, PcmYpzjkxx> implements IPcmYpzjkxxService {


    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(PcmYpzjkxx et) {
        if(!this.retBool(this.baseMapper.insert(et))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getPcmypzjkxxid()), et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<PcmYpzjkxx> list) {
        this.saveBatch(list, batchSize);
    }

    @Override
    @Transactional
    public boolean update(PcmYpzjkxx et) {
        if(!update(et, (Wrapper) et.getUpdateWrapper(true).eq("pcmypzjkxxid", et.getPcmypzjkxxid()))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getPcmypzjkxxid()), et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<PcmYpzjkxx> list) {
        updateBatchById(list, batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result = removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public PcmYpzjkxx get(String key) {
        PcmYpzjkxx et = getById(key);
        if(et == null){
            et = new PcmYpzjkxx();
            et.setPcmypzjkxxid(key);
        }
        else {
        }
        return et;
    }

    @Override
    public PcmYpzjkxx getDraft(PcmYpzjkxx et) {
        return et;
    }

    @Override
    public boolean checkKey(PcmYpzjkxx et) {
        return (!ObjectUtils.isEmpty(et.getPcmypzjkxxid())) && (!Objects.isNull(this.getById(et.getPcmypzjkxxid())));
    }
    @Override
    @Transactional
    public boolean save(PcmYpzjkxx et) {
        if(!saveOrUpdate(et)) {
            return false;
        }
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(PcmYpzjkxx et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<PcmYpzjkxx> list) {
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<PcmYpzjkxx> list) {
        saveOrUpdateBatch(list,batchSize);
    }



    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PcmYpzjkxx> searchDefault(PcmYpzjkxxSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PcmYpzjkxx> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<PcmYpzjkxx>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<PcmYpzjkxx> getPcmypzjkxxByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<PcmYpzjkxx> getPcmypzjkxxByEntities(List<PcmYpzjkxx> entities) {
        List ids =new ArrayList();
        for(PcmYpzjkxx entity : entities){
            Serializable id=entity.getPcmypzjkxxid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0) {
            return this.listByIds(ids);
        }
        else {
            return entities;
        }
    }




}



