package cn.ibizlab.ehr.core.pim.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import cn.ibizlab.ehr.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.ehr.core.pim.domain.PIMPERSONCHANGE;
/**
 * 关系型数据实体[PIMPERSONCHANGE] 查询条件对象
 */
@Slf4j
@Data
public class PIMPERSONCHANGESearchContext extends QueryWrapperContext<PIMPERSONCHANGE> {

	private String n_zt_eq;//[审批状态]
	public void setN_zt_eq(String n_zt_eq) {
        this.n_zt_eq = n_zt_eq;
        if(!ObjectUtils.isEmpty(this.n_zt_eq)){
            this.getSelectCond().eq("zt", n_zt_eq);
        }
    }
	private String n_bglx_eq;//[变更类型]
	public void setN_bglx_eq(String n_bglx_eq) {
        this.n_bglx_eq = n_bglx_eq;
        if(!ObjectUtils.isEmpty(this.n_bglx_eq)){
            this.getSelectCond().eq("bglx", n_bglx_eq);
        }
    }
	private String n_pimpersonchangename_like;//[人员信息变更审核名称]
	public void setN_pimpersonchangename_like(String n_pimpersonchangename_like) {
        this.n_pimpersonchangename_like = n_pimpersonchangename_like;
        if(!ObjectUtils.isEmpty(this.n_pimpersonchangename_like)){
            this.getSelectCond().like("pimpersonchangename", n_pimpersonchangename_like);
        }
    }
	private String n_pimpersonname_eq;//[员工姓名]
	public void setN_pimpersonname_eq(String n_pimpersonname_eq) {
        this.n_pimpersonname_eq = n_pimpersonname_eq;
        if(!ObjectUtils.isEmpty(this.n_pimpersonname_eq)){
            this.getSelectCond().eq("pimpersonname", n_pimpersonname_eq);
        }
    }
	private String n_pimpersonname_like;//[员工姓名]
	public void setN_pimpersonname_like(String n_pimpersonname_like) {
        this.n_pimpersonname_like = n_pimpersonname_like;
        if(!ObjectUtils.isEmpty(this.n_pimpersonname_like)){
            this.getSelectCond().like("pimpersonname", n_pimpersonname_like);
        }
    }
	private String n_pimpersonid_eq;//[人员信息标识]
	public void setN_pimpersonid_eq(String n_pimpersonid_eq) {
        this.n_pimpersonid_eq = n_pimpersonid_eq;
        if(!ObjectUtils.isEmpty(this.n_pimpersonid_eq)){
            this.getSelectCond().eq("pimpersonid", n_pimpersonid_eq);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.getSelectCond().or().like("pimpersonchangename",query);
			this.getSelectCond().or().like("pimpersonname",query);
		 }
	}
}




