package cn.ibizlab.ehr.core.pim.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.pim.domain.PimLwgz;
import cn.ibizlab.ehr.core.pim.filter.PimLwgzSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PimLwgz] 服务对象接口
 */
public interface IPimLwgzService extends IService<PimLwgz> {

    boolean create(PimLwgz et);
    void createBatch(List<PimLwgz> list);
    boolean update(PimLwgz et);
    void updateBatch(List<PimLwgz> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    PimLwgz get(String key);
    PimLwgz getDraft(PimLwgz et);
    boolean checkKey(PimLwgz et);
    boolean save(PimLwgz et);
    void saveBatch(List<PimLwgz> list);
    Page<PimLwgz> searchDefault(PimLwgzSearchContext context);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<PimLwgz> getPimlwgzByIds(List<String> ids);
    List<PimLwgz> getPimlwgzByEntities(List<PimLwgz> entities);
}


