package cn.ibizlab.ehr.core.pim.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.pim.domain.PimRewardPunishment;
import cn.ibizlab.ehr.core.pim.filter.PimRewardPunishmentSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PimRewardPunishment] 服务对象接口
 */
public interface IPimRewardPunishmentService extends IService<PimRewardPunishment> {

    boolean create(PimRewardPunishment et);
    void createBatch(List<PimRewardPunishment> list);
    boolean update(PimRewardPunishment et);
    void updateBatch(List<PimRewardPunishment> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    PimRewardPunishment get(String key);
    PimRewardPunishment getDraft(PimRewardPunishment et);
    boolean checkKey(PimRewardPunishment et);
    boolean save(PimRewardPunishment et);
    void saveBatch(List<PimRewardPunishment> list);
    Page<PimRewardPunishment> searchDefault(PimRewardPunishmentSearchContext context);
    Page<PimRewardPunishment> searchHONORARY(PimRewardPunishmentSearchContext context);
    Page<PimRewardPunishment> searchJLSS(PimRewardPunishmentSearchContext context);
    Page<PimRewardPunishment> searchZIZHU(PimRewardPunishmentSearchContext context);
    List<PimRewardPunishment> selectByPimpersonid(String pimpersonid);
    void removeByPimpersonid(String pimpersonid);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<PimRewardPunishment> getPimrewardpunishmentByIds(List<String> ids);
    List<PimRewardPunishment> getPimrewardpunishmentByEntities(List<PimRewardPunishment> entities);
}


