package cn.ibizlab.ehr.core.pim.service.logic.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.KieContainer;

import cn.ibizlab.ehr.core.pim.service.logic.IPIMBYZZJLMXSetSXRQLogic;
import cn.ibizlab.ehr.core.pim.domain.PIMBYZZJLMX;

/**
 * 关系型数据实体[SetSXRQ] 对象
 */
@Slf4j
@Service
public class PIMBYZZJLMXSetSXRQLogicImpl implements IPIMBYZZJLMXSetSXRQLogic{

    @Autowired
    private KieContainer kieContainer;


    @Autowired
    private cn.ibizlab.ehr.core.pim.service.IPIMBYZZJLMXService iBzSysDefaultService;

    public cn.ibizlab.ehr.core.pim.service.IPIMBYZZJLMXService getIBzSysDefaultService() {
        return this.iBzSysDefaultService;
    }

    public void execute(PIMBYZZJLMX et){

          KieSession kieSession = null;
        try{
           kieSession=kieContainer.newKieSession();
           kieSession.insert(et); 
           kieSession.setGlobal("pimbyzzjlmxsetsxrqdefault",et);
           kieSession.setGlobal("iBzSysPimbyzzjlmxDefaultService",iBzSysDefaultService);
           kieSession.setGlobal("curuser", cn.ibizlab.ehr.util.security.AuthenticationUser.getAuthenticationUser());
           kieSession.startProcess("cn.ibizlab.ehr.core.pim.service.logic.pimbyzzjlmxsetsxrq");

        }catch(Exception e){
            throw new RuntimeException("执行[设置生效日期]处理逻辑发生异常"+e);
        }finally {
            if(kieSession!=null)
            kieSession.destroy();
        }
    }

}
