package cn.ibizlab.ehr.core.pim.service.logic.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.KieContainer;

import cn.ibizlab.ehr.core.pim.service.logic.IPimByzzjlmxFillPersonInfoLogic;
import cn.ibizlab.ehr.core.pim.domain.PimByzzjlmx;

/**
 * 关系型数据实体[FillPersonInfo] 对象
 */
@Slf4j
@Service
public class PimByzzjlmxFillPersonInfoLogicImpl implements IPimByzzjlmxFillPersonInfoLogic {

    @Autowired
    private KieContainer kieContainer;

    @Autowired
    private cn.ibizlab.ehr.core.pim.service.IPimPersonService pimpersonservice;

    public cn.ibizlab.ehr.core.pim.service.IPimPersonService getPimpersonService() {
        return this.pimpersonservice;
    }


    @Autowired
    private cn.ibizlab.ehr.core.pim.service.IPimByzzjlmxService iBzSysDefaultService;

    public cn.ibizlab.ehr.core.pim.service.IPimByzzjlmxService getIBzSysDefaultService() {
        return this.iBzSysDefaultService;
    }

    @Override
    public void execute(PimByzzjlmx et) {

          KieSession kieSession = null;
        try{
           kieSession = kieContainer.newKieSession();
           kieSession.insert(et); 
           kieSession.setGlobal("pimbyzzjlmxfillpersoninfodefault", et);
           cn.ibizlab.ehr.core.pim.domain.PimPerson pimbyzzjlmxfillpersoninfopimperson = new cn.ibizlab.ehr.core.pim.domain.PimPerson();
           kieSession.insert(pimbyzzjlmxfillpersoninfopimperson); 
           kieSession.setGlobal("pimbyzzjlmxfillpersoninfopimperson", pimbyzzjlmxfillpersoninfopimperson);
           kieSession.setGlobal("pimpersonservice", pimpersonservice);
           kieSession.setGlobal("iBzSysPimbyzzjlmxDefaultService", iBzSysDefaultService);
           kieSession.setGlobal("curuser", cn.ibizlab.ehr.util.security.AuthenticationUser.getAuthenticationUser());
           kieSession.startProcess("cn.ibizlab.ehr.core.pim.service.logic.pimbyzzjlmxfillpersoninfo");

        }catch(Exception e) {
            throw new RuntimeException("执行[填充人员信息]处理逻辑发生异常"+e);
        }finally {
            if(kieSession!=null) {
                kieSession.destroy();
            }
        }
    }

}
