package cn.ibizlab.ehr.core.sal.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.sal.domain.SalStdzj;
import cn.ibizlab.ehr.core.sal.filter.SalStdzjSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[SalStdzj] 服务对象接口
 */
public interface ISalStdzjService extends IService<SalStdzj> {

    boolean create(SalStdzj et);
    void createBatch(List<SalStdzj> list);
    boolean update(SalStdzj et);
    void updateBatch(List<SalStdzj> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    SalStdzj get(String key);
    SalStdzj getDraft(SalStdzj et);
    boolean checkKey(SalStdzj et);
    boolean save(SalStdzj et);
    void saveBatch(List<SalStdzj> list);
    Page<SalStdzj> searchDefault(SalStdzjSearchContext context);
    List<SalStdzj> selectByOrmorgid(String orgid);
    void removeByOrmorgid(String orgid);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<SalStdzj> getSalstdzjByIds(List<String> ids);
    List<SalStdzj> getSalstdzjByEntities(List<SalStdzj> entities);
}


