package cn.ibizlab.ehr.core.soc.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import cn.ibizlab.ehr.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.ehr.core.soc.domain.SOCSELFAREBASE;
/**
 * 关系型数据实体[SOCSELFAREBASE] 查询条件对象
 */
@Slf4j
@Data
public class SOCSELFAREBASESearchContext extends QueryWrapperContext<SOCSELFAREBASE> {

	private String n_socselfarebasename_like;//[参保地名称]
	public void setN_socselfarebasename_like(String n_socselfarebasename_like) {
        this.n_socselfarebasename_like = n_socselfarebasename_like;
        if(!ObjectUtils.isEmpty(this.n_socselfarebasename_like)){
            this.getSelectCond().like("socselfarebasename", n_socselfarebasename_like);
        }
    }
	private String n_cbdq_eq;//[参保地区]
	public void setN_cbdq_eq(String n_cbdq_eq) {
        this.n_cbdq_eq = n_cbdq_eq;
        if(!ObjectUtils.isEmpty(this.n_cbdq_eq)){
            this.getSelectCond().eq("cbdq", n_cbdq_eq);
        }
    }
	private String n_sblx_eq;//[社保福利类型]
	public void setN_sblx_eq(String n_sblx_eq) {
        this.n_sblx_eq = n_sblx_eq;
        if(!ObjectUtils.isEmpty(this.n_sblx_eq)){
            this.getSelectCond().eq("sblx", n_sblx_eq);
        }
    }
	private String n_cbdw_eq;//[参保单位]
	public void setN_cbdw_eq(String n_cbdw_eq) {
        this.n_cbdw_eq = n_cbdw_eq;
        if(!ObjectUtils.isEmpty(this.n_cbdw_eq)){
            this.getSelectCond().eq("cbdw", n_cbdw_eq);
        }
    }
	private String n_ormorgname_eq;//[组织]
	public void setN_ormorgname_eq(String n_ormorgname_eq) {
        this.n_ormorgname_eq = n_ormorgname_eq;
        if(!ObjectUtils.isEmpty(this.n_ormorgname_eq)){
            this.getSelectCond().eq("ormorgname", n_ormorgname_eq);
        }
    }
	private String n_ormorgname_like;//[组织]
	public void setN_ormorgname_like(String n_ormorgname_like) {
        this.n_ormorgname_like = n_ormorgname_like;
        if(!ObjectUtils.isEmpty(this.n_ormorgname_like)){
            this.getSelectCond().like("ormorgname", n_ormorgname_like);
        }
    }
	private String n_ormorgid_eq;//[组织标识]
	public void setN_ormorgid_eq(String n_ormorgid_eq) {
        this.n_ormorgid_eq = n_ormorgid_eq;
        if(!ObjectUtils.isEmpty(this.n_ormorgid_eq)){
            this.getSelectCond().eq("ormorgid", n_ormorgid_eq);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.getSelectCond().or().like("socselfarebasename",query);
		 }
	}
}




