package cn.ibizlab.ehr.core.trm.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.ehr.util.domain.EntityBase;
import cn.ibizlab.ehr.util.annotation.DEField;
import cn.ibizlab.ehr.util.enums.DEPredefinedFieldType;
import cn.ibizlab.ehr.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.Data;
import org.springframework.data.annotation.Transient;


import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.ehr.util.domain.EntityMP;

/**
 * 实体[培训模块]
 */
@Data
@TableName(value = "T_TRMCOURSESYSTEM",resultMap = "TRMCOURSESYSTEMResultMap")
public class TRMCOURSESYSTEM extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 对应关系
     */
    @TableField(value = "dygx")
    @JSONField(name = "dygx")
    @JsonProperty("dygx")
    private String dygx;
    /**
     * 名称
     */
    @TableField(value = "trmcoursesystemname")
    @JSONField(name = "trmcoursesystemname")
    @JsonProperty("trmcoursesystemname")
    private String trmcoursesystemname;
    /**
     * 课程体系标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "trmcoursesystemid",type=IdType.UUID)
    @JSONField(name = "trmcoursesystemid")
    @JsonProperty("trmcoursesystemid")
    private String trmcoursesystemid;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 级别
     */
    @TableField(value = "jb")
    @JSONField(name = "jb")
    @JsonProperty("jb")
    private String jb;
    /**
     * 内容
     */
    @TableField(value = "nr")
    @JSONField(name = "nr")
    @JsonProperty("nr")
    private String nr;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 创建日期
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 逻辑有效标志
     */
    @DEField(preType = DEPredefinedFieldType.LOGICVALID, logicval = "1" , logicdelval="0")
    @TableLogic(value= "1",delval="0")
    @TableField(value = "enable")
    @JSONField(name = "enable")
    @JsonProperty("enable")
    private Integer enable;
    /**
     * 代码
     */
    @TableField(value = "dm")
    @JSONField(name = "dm")
    @JsonProperty("dm")
    private String dm;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 培训机构
     */
    @TableField(exist = false)
    @JSONField(name = "trmtrainagencyname")
    @JsonProperty("trmtrainagencyname")
    private String trmtrainagencyname;
    /**
     * 培训机构标识
     */
    @TableField(value = "trmtrainagencyid")
    @JSONField(name = "trmtrainagencyid")
    @JsonProperty("trmtrainagencyid")
    private String trmtrainagencyid;

    /**
     * 课程模块
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.ehr.core.trm.domain.TRMTRAINAGENCY trmtrainagency;



    /**
     * 设置 [对应关系]
     */
    public void setDygx(String dygx){
        this.dygx = dygx ;
        this.modify("dygx",dygx);
    }
    /**
     * 设置 [名称]
     */
    public void setTrmcoursesystemname(String trmcoursesystemname){
        this.trmcoursesystemname = trmcoursesystemname ;
        this.modify("trmcoursesystemname",trmcoursesystemname);
    }
    /**
     * 设置 [级别]
     */
    public void setJb(String jb){
        this.jb = jb ;
        this.modify("jb",jb);
    }
    /**
     * 设置 [内容]
     */
    public void setNr(String nr){
        this.nr = nr ;
        this.modify("nr",nr);
    }
    /**
     * 设置 [代码]
     */
    public void setDm(String dm){
        this.dm = dm ;
        this.modify("dm",dm);
    }
    /**
     * 设置 [培训机构标识]
     */
    public void setTrmtrainagencyid(String trmtrainagencyid){
        this.trmtrainagencyid = trmtrainagencyid ;
        this.modify("trmtrainagencyid",trmtrainagencyid);
    }
}






