package cn.ibizlab.ehr.core.trm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.ehr.core.trm.domain.TrmTraffic;
import cn.ibizlab.ehr.core.trm.filter.TrmTrafficSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[TrmTraffic] 服务对象接口
 */
public interface ITrmTrafficService extends IService<TrmTraffic> {

    boolean create(TrmTraffic et);
    void createBatch(List<TrmTraffic> list);
    boolean update(TrmTraffic et);
    void updateBatch(List<TrmTraffic> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    TrmTraffic get(String key);
    TrmTraffic getDraft(TrmTraffic et);
    boolean checkKey(TrmTraffic et);
    boolean save(TrmTraffic et);
    void saveBatch(List<TrmTraffic> list);
    Page<TrmTraffic> searchDefault(TrmTrafficSearchContext context);
    List<TrmTraffic> selectByTrmtrainaddressid(String trmtrainaddressid);
    void removeByTrmtrainaddressid(String trmtrainaddressid);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<TrmTraffic> getTrmtrafficByIds(List<String> ids);
    List<TrmTraffic> getTrmtrafficByEntities(List<TrmTraffic> entities);
}


