package cn.ibizlab.ehr.core.vac.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.ehr.util.domain.EntityBase;
import cn.ibizlab.ehr.util.annotation.DEField;
import cn.ibizlab.ehr.util.enums.DEPredefinedFieldType;
import cn.ibizlab.ehr.util.enums.DEFieldDefaultValueType;
import cn.ibizlab.ehr.util.helper.DataObject;
import cn.ibizlab.ehr.util.enums.DupCheck;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.ehr.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.ehr.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[工作日管理（停用）]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_VACWORKDAY", resultMap = "VacWorkDayResultMap")
public class VacWorkDay extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 年度
     */
    @TableField(value = "nd")
    @JSONField(name = "nd")
    @JsonProperty("nd")
    private String nd;
    /**
     * 工作日管理标识
     */
    @DEField(isKeyField = true)
    @TableId(value = "vacworkdayid", type = IdType.ASSIGN_UUID)
    @JSONField(name = "vacworkdayid")
    @JsonProperty("vacworkdayid")
    private String vacworkdayid;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate", fill = FieldFill.INSERT)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "createdate", format = "yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 工作日
     */
    @TableField(value = "vacworkdayname")
    @JSONField(name = "vacworkdayname")
    @JsonProperty("vacworkdayname")
    private String vacworkdayname;
    /**
     * 备注
     */
    @TableField(value = "bz")
    @JSONField(name = "bz")
    @JsonProperty("bz")
    private String bz;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 结束时间
     */
    @TableField(value = "jssj")
    @JsonFormat(pattern = "yyyy-MM-dd", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "jssj", format = "yyyy-MM-dd")
    @JsonProperty("jssj")
    private Timestamp jssj;
    /**
     * 上班时间
     */
    @TableField(value = "sbsj")
    @JsonFormat(pattern = "HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "sbsj", format = "HH:mm:ss")
    @JsonProperty("sbsj")
    private Timestamp sbsj;
    /**
     * 下班时间
     */
    @TableField(value = "xbsj")
    @JsonFormat(pattern = "HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "xbsj", format = "HH:mm:ss")
    @JsonProperty("xbsj")
    private Timestamp xbsj;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman", fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 开始时间
     */
    @TableField(value = "kssj")
    @JsonFormat(pattern = "yyyy-MM-dd", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "kssj", format = "yyyy-MM-dd")
    @JsonProperty("kssj")
    private Timestamp kssj;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "updatedate", format = "yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 逻辑有效标志
     */
    @DEField(preType = DEPredefinedFieldType.LOGICVALID)
    @TableField(value = "enable")
    @JSONField(name = "enable")
    @JsonProperty("enable")
    private Integer enable;



    /**
     * 设置 [年度]
     */
    public void setNd(String nd) {
        this.nd = nd;
        this.modify("nd", nd);
    }

    /**
     * 设置 [工作日]
     */
    public void setVacworkdayname(String vacworkdayname) {
        this.vacworkdayname = vacworkdayname;
        this.modify("vacworkdayname", vacworkdayname);
    }

    /**
     * 设置 [备注]
     */
    public void setBz(String bz) {
        this.bz = bz;
        this.modify("bz", bz);
    }

    /**
     * 设置 [结束时间]
     */
    public void setJssj(Timestamp jssj) {
        this.jssj = jssj;
        this.modify("jssj", jssj);
    }

    /**
     * 格式化日期 [结束时间]
     */
    public String formatJssj() {
        if (this.jssj == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(jssj);
    }
    /**
     * 设置 [上班时间]
     */
    public void setSbsj(Timestamp sbsj) {
        this.sbsj = sbsj;
        this.modify("sbsj", sbsj);
    }

    /**
     * 格式化日期 [上班时间]
     */
    public String formatSbsj() {
        if (this.sbsj == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
        return sdf.format(sbsj);
    }
    /**
     * 设置 [下班时间]
     */
    public void setXbsj(Timestamp xbsj) {
        this.xbsj = xbsj;
        this.modify("xbsj", xbsj);
    }

    /**
     * 格式化日期 [下班时间]
     */
    public String formatXbsj() {
        if (this.xbsj == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
        return sdf.format(xbsj);
    }
    /**
     * 设置 [开始时间]
     */
    public void setKssj(Timestamp kssj) {
        this.kssj = kssj;
        this.modify("kssj", kssj);
    }

    /**
     * 格式化日期 [开始时间]
     */
    public String formatKssj() {
        if (this.kssj == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(kssj);
    }

    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("vacworkdayid");
        return super.copyTo(targetEntity, bIncEmpty);
    }
}


